// *** WARNING: this file was generated by crd2pulumi. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***

import * as pulumi from "@pulumi/pulumi";
import * as inputs from "../../types/input";
import * as outputs from "../../types/output";
import * as utilities from "../../utilities";

import {ObjectMeta} from "../../meta/v1";

/**
 * Alertmanager describes an Alertmanager cluster.
 */
export class Alertmanager extends pulumi.CustomResource {
    /**
     * Get an existing Alertmanager resource's state with the given name, ID, and optional extra
     * properties used to qualify the lookup.
     *
     * @param name The _unique_ name of the resulting resource.
     * @param id The _unique_ provider ID of the resource to lookup.
     * @param opts Optional settings to control the behavior of the CustomResource.
     */
    public static get(name: string, id: pulumi.Input<pulumi.ID>, opts?: pulumi.CustomResourceOptions): Alertmanager {
        return new Alertmanager(name, undefined as any, { ...opts, id: id });
    }

    /** @internal */
    public static readonly __pulumiType = 'kubernetes:monitoring.coreos.com/v1:Alertmanager';

    /**
     * Returns true if the given object is an instance of Alertmanager.  This is designed to work even
     * when multiple copies of the Pulumi SDK have been loaded into the same process.
     */
    public static isInstance(obj: any): obj is Alertmanager {
        if (obj === undefined || obj === null) {
            return false;
        }
        return obj['__pulumiType'] === Alertmanager.__pulumiType;
    }

    public readonly apiVersion!: pulumi.Output<"monitoring.coreos.com/v1" | undefined>;
    public readonly kind!: pulumi.Output<"Alertmanager" | undefined>;
    public readonly metadata!: pulumi.Output<ObjectMeta | undefined>;
    /**
     * Specification of the desired behavior of the Alertmanager cluster. More info: https://github.com/kubernetes/community/blob/master/contributors/devel/sig-architecture/api-conventions.md#spec-and-status
     */
    public readonly spec!: pulumi.Output<outputs.monitoring.v1.AlertmanagerSpec>;
    /**
     * Most recent observed status of the Alertmanager cluster. Read-only. Not included when requesting from the apiserver, only from the Prometheus Operator API itself. More info: https://github.com/kubernetes/community/blob/master/contributors/devel/sig-architecture/api-conventions.md#spec-and-status
     */
    public readonly status!: pulumi.Output<outputs.monitoring.v1.AlertmanagerStatus | undefined>;

    /**
     * Create a Alertmanager resource with the given unique name, arguments, and options.
     *
     * @param name The _unique_ name of the resource.
     * @param args The arguments to use to populate this resource's properties.
     * @param opts A bag of options that control this resource's behavior.
     */
    constructor(name: string, args?: AlertmanagerArgs, opts?: pulumi.CustomResourceOptions) {
        let inputs: pulumi.Inputs = {};
        if (!(opts && opts.id)) {
            inputs["apiVersion"] = "monitoring.coreos.com/v1";
            inputs["kind"] = "Alertmanager";
            inputs["metadata"] = args ? args.metadata : undefined;
            inputs["spec"] = args ? args.spec : undefined;
            inputs["status"] = args ? args.status : undefined;
        } else {
            inputs["apiVersion"] = undefined /*out*/;
            inputs["kind"] = undefined /*out*/;
            inputs["metadata"] = undefined /*out*/;
            inputs["spec"] = undefined /*out*/;
            inputs["status"] = undefined /*out*/;
        }
        if (!opts) {
            opts = {}
        }

        if (!opts.version) {
            opts.version = utilities.getVersion();
        }
        super(Alertmanager.__pulumiType, name, inputs, opts);
    }
}

/**
 * The set of arguments for constructing a Alertmanager resource.
 */
export interface AlertmanagerArgs {
    readonly apiVersion?: pulumi.Input<"monitoring.coreos.com/v1">;
    readonly kind?: pulumi.Input<"Alertmanager">;
    readonly metadata?: pulumi.Input<ObjectMeta>;
    /**
     * Specification of the desired behavior of the Alertmanager cluster. More info: https://github.com/kubernetes/community/blob/master/contributors/devel/sig-architecture/api-conventions.md#spec-and-status
     */
    readonly spec?: pulumi.Input<inputs.monitoring.v1.AlertmanagerSpec>;
    /**
     * Most recent observed status of the Alertmanager cluster. Read-only. Not included when requesting from the apiserver, only from the Prometheus Operator API itself. More info: https://github.com/kubernetes/community/blob/master/contributors/devel/sig-architecture/api-conventions.md#spec-and-status
     */
    readonly status?: pulumi.Input<inputs.monitoring.v1.AlertmanagerStatus>;
}
